import { Text as Ae, Transaction as De, StateEffect as T, Prec as _, RangeValue as Le, Annotation as Me, StateField as ee, EditorSelection as C, Facet as me, codePointSize as I, codePointAt as v, CharCategory as Y, combineConfig as Be, MapMode as G, RangeSet as ke, fromCodePoint as ge } from "./lib20.js";
import { keymap as ye, EditorView as D, Decoration as V, showTooltip as Fe, getTooltip as be, ViewPlugin as je, logException as J, WidgetType as $e, Direction as Ue } from "./lib21.js";
import { syntaxTree as H, indentUnit as We } from "./lib8.js";
class xe {
  /**
  Create a new completion context. (Mostly useful for testing
  completion sources—in the editor, the extension will create
  these for you.)
  */
  constructor(e, t, n) {
    this.state = e, this.pos = t, this.explicit = n, this.abortListeners = [];
  }
  /**
  Get the extent, content, and (if there is a token) type of the
  token before `this.pos`.
  */
  tokenBefore(e) {
    let t = H(this.state).resolveInner(this.pos, -1);
    for (; t && e.indexOf(t.name) < 0; )
      t = t.parent;
    return t ? {
      from: t.from,
      to: this.pos,
      text: this.state.sliceDoc(t.from, this.pos),
      type: t.type
    } : null;
  }
  /**
  Get the match of the given expression directly before the
  cursor.
  */
  matchBefore(e) {
    let t = this.state.doc.lineAt(this.pos), n = Math.max(t.from, this.pos - 250), s = t.text.slice(n - t.from, this.pos - t.from), o = s.search(we(e, !1));
    return o < 0 ? null : { from: n + o, to: this.pos, text: s.slice(o) };
  }
  /**
  Yields true when the query has been aborted. Can be useful in
  asynchronous queries to avoid doing work that will be ignored.
  */
  get aborted() {
    return this.abortListeners == null;
  }
  /**
  Allows you to register abort handlers, which will be called when
  the query is
  [aborted](https://codemirror.net/6/docs/ref/#autocomplete.CompletionContext.aborted).
  */
  addEventListener(e, t) {
    e == "abort" && this.abortListeners && this.abortListeners.push(t);
  }
}
function le(i) {
  let e = Object.keys(i).join(""), t = /\w/.test(e);
  return t && (e = e.replace(/\w/g, "")), `[${t ? "\\w" : ""}${e.replace(/[^\w\s]/g, "\\$&")}]`;
}
function Ne(i) {
  let e = /* @__PURE__ */ Object.create(null), t = /* @__PURE__ */ Object.create(null);
  for (let { label: s } of i) {
    e[s[0]] = !0;
    for (let o = 1; o < s.length; o++)
      t[s[o]] = !0;
  }
  let n = le(e) + le(t) + "*$";
  return [new RegExp("^" + n), new RegExp(n)];
}
function Ve(i) {
  let e = i.map((s) => typeof s == "string" ? { label: s } : s), [t, n] = e.every((s) => /^\w+$/.test(s.label)) ? [/\w*$/, /\w+$/] : Ne(e);
  return (s) => {
    let o = s.matchBefore(n);
    return o || s.explicit ? { from: o ? o.from : s.pos, options: e, validFor: t } : null;
  };
}
function $t(i, e) {
  return (t) => {
    for (let n = H(t.state).resolveInner(t.pos, -1); n; n = n.parent) {
      if (i.indexOf(n.name) > -1)
        return null;
      if (n.type.isTop)
        break;
    }
    return e(t);
  };
}
class re {
  constructor(e, t, n, s) {
    this.completion = e, this.source = t, this.match = n, this.score = s;
  }
}
function O(i) {
  return i.selection.main.from;
}
function we(i, e) {
  var t;
  let { source: n } = i, s = e && n[0] != "^", o = n[n.length - 1] != "$";
  return !s && !o ? i : new RegExp(`${s ? "^" : ""}(?:${n})${o ? "$" : ""}`, (t = i.flags) !== null && t !== void 0 ? t : i.ignoreCase ? "i" : "");
}
const Ce = /* @__PURE__ */ Me.define();
function He(i, e, t, n) {
  let { main: s } = i.selection, o = t - s.from, l = n - s.from;
  return Object.assign(Object.assign({}, i.changeByRange((r) => r != s && t != n && i.sliceDoc(r.from + o, r.from + l) != i.sliceDoc(t, n) ? { range: r } : {
    changes: { from: r.from + o, to: n == s.from ? r.to : r.from + l, insert: e },
    range: C.cursor(r.from + o + e.length)
  })), { scrollIntoView: !0, userEvent: "input.complete" });
}
const ae = /* @__PURE__ */ new WeakMap();
function qe(i) {
  if (!Array.isArray(i))
    return i;
  let e = ae.get(i);
  return e || ae.set(i, e = Ve(i)), e;
}
const W = /* @__PURE__ */ T.define(), B = /* @__PURE__ */ T.define();
class ze {
  constructor(e) {
    this.pattern = e, this.chars = [], this.folded = [], this.any = [], this.precise = [], this.byWord = [], this.score = 0, this.matched = [];
    for (let t = 0; t < e.length; ) {
      let n = v(e, t), s = I(n);
      this.chars.push(n);
      let o = e.slice(t, t + s), l = o.toUpperCase();
      this.folded.push(v(l == o ? o.toLowerCase() : l, 0)), t += s;
    }
    this.astral = e.length != this.chars.length;
  }
  ret(e, t) {
    return this.score = e, this.matched = t, this;
  }
  // Matches a given word (completion) against the pattern (input).
  // Will return a boolean indicating whether there was a match and,
  // on success, set `this.score` to the score, `this.matched` to an
  // array of `from, to` pairs indicating the matched parts of `word`.
  //
  // The score is a number that is more negative the worse the match
  // is. See `Penalty` above.
  match(e) {
    if (this.pattern.length == 0)
      return this.ret(-100, []);
    if (e.length < this.pattern.length)
      return null;
    let { chars: t, folded: n, any: s, precise: o, byWord: l } = this;
    if (t.length == 1) {
      let d = v(e, 0), P = I(d), S = P == e.length ? 0 : -100;
      if (d != t[0])
        if (d == n[0])
          S += -200;
        else
          return null;
      return this.ret(S, [0, P]);
    }
    let r = e.indexOf(this.pattern);
    if (r == 0)
      return this.ret(e.length == this.pattern.length ? 0 : -100, [0, this.pattern.length]);
    let a = t.length, c = 0;
    if (r < 0) {
      for (let d = 0, P = Math.min(e.length, 200); d < P && c < a; ) {
        let S = v(e, d);
        (S == t[c] || S == n[c]) && (s[c++] = d), d += I(S);
      }
      if (c < a)
        return null;
    }
    let f = 0, h = 0, p = !1, u = 0, m = -1, w = -1, z = /[a-z]/.test(e), M = !0;
    for (let d = 0, P = Math.min(e.length, 200), S = 0; d < P && h < a; ) {
      let b = v(e, d);
      r < 0 && (f < a && b == t[f] && (o[f++] = d), u < a && (b == t[u] || b == n[u] ? (u == 0 && (m = d), w = d + 1, u++) : u = 0));
      let $, K = b < 255 ? b >= 48 && b <= 57 || b >= 97 && b <= 122 ? 2 : b >= 65 && b <= 90 ? 1 : 0 : ($ = ge(b)) != $.toLowerCase() ? 1 : $ != $.toUpperCase() ? 2 : 0;
      (!d || K == 1 && z || S == 0 && K != 0) && (t[h] == b || n[h] == b && (p = !0) ? l[h++] = d : l.length && (M = !1)), S = K, d += I(b);
    }
    return h == a && l[0] == 0 && M ? this.result(-100 + (p ? -200 : 0), l, e) : u == a && m == 0 ? this.ret(-200 - e.length + (w == e.length ? 0 : -100), [0, w]) : r > -1 ? this.ret(-700 - e.length, [r, r + this.pattern.length]) : u == a ? this.ret(-900 - e.length, [m, w]) : h == a ? this.result(-100 + (p ? -200 : 0) + -700 + (M ? 0 : -1100), l, e) : t.length == 2 ? null : this.result((s[0] ? -700 : 0) + -200 + -1100, s, e);
  }
  result(e, t, n) {
    let s = [], o = 0;
    for (let l of t) {
      let r = l + (this.astral ? I(v(n, l)) : 1);
      o && s[o - 1] == l ? s[o - 1] = r : (s[o++] = l, s[o++] = r);
    }
    return this.ret(e - n.length, s);
  }
}
class Ke {
  constructor(e) {
    this.pattern = e, this.matched = [], this.score = 0, this.folded = e.toLowerCase();
  }
  match(e) {
    if (e.length < this.pattern.length)
      return null;
    let t = e.slice(0, this.pattern.length), n = t == this.pattern ? 0 : t.toLowerCase() == this.folded ? -200 : null;
    return n == null ? null : (this.matched = [0, t.length], this.score = n + (e.length == this.pattern.length ? 0 : -100), this);
  }
}
const g = /* @__PURE__ */ me.define({
  combine(i) {
    return Be(i, {
      activateOnTyping: !0,
      activateOnTypingDelay: 100,
      selectOnOpen: !0,
      override: null,
      closeOnBlur: !0,
      maxRenderedOptions: 100,
      defaultKeymap: !0,
      tooltipClass: () => "",
      optionClass: () => "",
      aboveCursor: !1,
      icons: !0,
      addToOptions: [],
      positionInfo: Qe,
      filterStrict: !1,
      compareCompletions: (e, t) => e.label.localeCompare(t.label),
      interactionDelay: 75,
      updateSyncTime: 100
    }, {
      defaultKeymap: (e, t) => e && t,
      closeOnBlur: (e, t) => e && t,
      icons: (e, t) => e && t,
      tooltipClass: (e, t) => (n) => ce(e(n), t(n)),
      optionClass: (e, t) => (n) => ce(e(n), t(n)),
      addToOptions: (e, t) => e.concat(t),
      filterStrict: (e, t) => e || t
    });
  }
});
function ce(i, e) {
  return i ? e ? i + " " + e : i : e;
}
function Qe(i, e, t, n, s, o) {
  let l = i.textDirection == Ue.RTL, r = l, a = !1, c = "top", f, h, p = e.left - s.left, u = s.right - e.right, m = n.right - n.left, w = n.bottom - n.top;
  if (r && p < Math.min(m, u) ? r = !1 : !r && u < Math.min(m, p) && (r = !0), m <= (r ? p : u))
    f = Math.max(s.top, Math.min(t.top, s.bottom - w)) - e.top, h = Math.min(400, r ? p : u);
  else {
    a = !0, h = Math.min(
      400,
      (l ? e.right : s.right - e.left) - 30
      /* Info.Margin */
    );
    let d = s.bottom - e.bottom;
    d >= w || d > e.top ? f = t.bottom - e.top : (c = "bottom", f = e.bottom - t.top);
  }
  let z = (e.bottom - e.top) / o.offsetHeight, M = (e.right - e.left) / o.offsetWidth;
  return {
    style: `${c}: ${f / z}px; max-width: ${h / M}px`,
    class: "cm-completionInfo-" + (a ? l ? "left-narrow" : "right-narrow" : r ? "left" : "right")
  };
}
function Xe(i) {
  let e = i.addToOptions.slice();
  return i.icons && e.push({
    render(t) {
      let n = document.createElement("div");
      return n.classList.add("cm-completionIcon"), t.type && n.classList.add(...t.type.split(/\s+/g).map((s) => "cm-completionIcon-" + s)), n.setAttribute("aria-hidden", "true"), n;
    },
    position: 20
  }), e.push({
    render(t, n, s, o) {
      let l = document.createElement("span");
      l.className = "cm-completionLabel";
      let r = t.displayLabel || t.label, a = 0;
      for (let c = 0; c < o.length; ) {
        let f = o[c++], h = o[c++];
        f > a && l.appendChild(document.createTextNode(r.slice(a, f)));
        let p = l.appendChild(document.createElement("span"));
        p.appendChild(document.createTextNode(r.slice(f, h))), p.className = "cm-completionMatchedText", a = h;
      }
      return a < r.length && l.appendChild(document.createTextNode(r.slice(a))), l;
    },
    position: 50
  }, {
    render(t) {
      if (!t.detail)
        return null;
      let n = document.createElement("span");
      return n.className = "cm-completionDetail", n.textContent = t.detail, n;
    },
    position: 80
  }), e.sort((t, n) => t.position - n.position).map((t) => t.render);
}
function Q(i, e, t) {
  if (i <= t)
    return { from: 0, to: i };
  if (e < 0 && (e = 0), e <= i >> 1) {
    let s = Math.floor(e / t);
    return { from: s * t, to: (s + 1) * t };
  }
  let n = Math.floor((i - e) / t);
  return { from: i - (n + 1) * t, to: i - n * t };
}
class Ye {
  constructor(e, t, n) {
    this.view = e, this.stateField = t, this.applyCompletion = n, this.info = null, this.infoDestroy = null, this.placeInfoReq = {
      read: () => this.measureInfo(),
      write: (a) => this.placeInfo(a),
      key: this
    }, this.space = null, this.currentClass = "";
    let s = e.state.field(t), { options: o, selected: l } = s.open, r = e.state.facet(g);
    this.optionContent = Xe(r), this.optionClass = r.optionClass, this.tooltipClass = r.tooltipClass, this.range = Q(o.length, l, r.maxRenderedOptions), this.dom = document.createElement("div"), this.dom.className = "cm-tooltip-autocomplete", this.updateTooltipClass(e.state), this.dom.addEventListener("mousedown", (a) => {
      let { options: c } = e.state.field(t).open;
      for (let f = a.target, h; f && f != this.dom; f = f.parentNode)
        if (f.nodeName == "LI" && (h = /-(\d+)$/.exec(f.id)) && +h[1] < c.length) {
          this.applyCompletion(e, c[+h[1]]), a.preventDefault();
          return;
        }
    }), this.dom.addEventListener("focusout", (a) => {
      let c = e.state.field(this.stateField, !1);
      c && c.tooltip && e.state.facet(g).closeOnBlur && a.relatedTarget != e.contentDOM && e.dispatch({ effects: B.of(null) });
    }), this.showOptions(o, s.id);
  }
  mount() {
    this.updateSel();
  }
  showOptions(e, t) {
    this.list && this.list.remove(), this.list = this.dom.appendChild(this.createListBox(e, t, this.range)), this.list.addEventListener("scroll", () => {
      this.info && this.view.requestMeasure(this.placeInfoReq);
    });
  }
  update(e) {
    var t;
    let n = e.state.field(this.stateField), s = e.startState.field(this.stateField);
    if (this.updateTooltipClass(e.state), n != s) {
      let { options: o, selected: l, disabled: r } = n.open;
      (!s.open || s.open.options != o) && (this.range = Q(o.length, l, e.state.facet(g).maxRenderedOptions), this.showOptions(o, n.id)), this.updateSel(), r != ((t = s.open) === null || t === void 0 ? void 0 : t.disabled) && this.dom.classList.toggle("cm-tooltip-autocomplete-disabled", !!r);
    }
  }
  updateTooltipClass(e) {
    let t = this.tooltipClass(e);
    if (t != this.currentClass) {
      for (let n of this.currentClass.split(" "))
        n && this.dom.classList.remove(n);
      for (let n of t.split(" "))
        n && this.dom.classList.add(n);
      this.currentClass = t;
    }
  }
  positioned(e) {
    this.space = e, this.info && this.view.requestMeasure(this.placeInfoReq);
  }
  updateSel() {
    let e = this.view.state.field(this.stateField), t = e.open;
    if ((t.selected > -1 && t.selected < this.range.from || t.selected >= this.range.to) && (this.range = Q(t.options.length, t.selected, this.view.state.facet(g).maxRenderedOptions), this.showOptions(t.options, e.id)), this.updateSelectedOption(t.selected)) {
      this.destroyInfo();
      let { completion: n } = t.options[t.selected], { info: s } = n;
      if (!s)
        return;
      let o = typeof s == "string" ? document.createTextNode(s) : s(n);
      if (!o)
        return;
      "then" in o ? o.then((l) => {
        l && this.view.state.field(this.stateField, !1) == e && this.addInfoPane(l, n);
      }).catch((l) => J(this.view.state, l, "completion info")) : this.addInfoPane(o, n);
    }
  }
  addInfoPane(e, t) {
    this.destroyInfo();
    let n = this.info = document.createElement("div");
    if (n.className = "cm-tooltip cm-completionInfo", e.nodeType != null)
      n.appendChild(e), this.infoDestroy = null;
    else {
      let { dom: s, destroy: o } = e;
      n.appendChild(s), this.infoDestroy = o || null;
    }
    this.dom.appendChild(n), this.view.requestMeasure(this.placeInfoReq);
  }
  updateSelectedOption(e) {
    let t = null;
    for (let n = this.list.firstChild, s = this.range.from; n; n = n.nextSibling, s++)
      n.nodeName != "LI" || !n.id ? s-- : s == e ? n.hasAttribute("aria-selected") || (n.setAttribute("aria-selected", "true"), t = n) : n.hasAttribute("aria-selected") && n.removeAttribute("aria-selected");
    return t && Je(this.list, t), t;
  }
  measureInfo() {
    let e = this.dom.querySelector("[aria-selected]");
    if (!e || !this.info)
      return null;
    let t = this.dom.getBoundingClientRect(), n = this.info.getBoundingClientRect(), s = e.getBoundingClientRect(), o = this.space;
    if (!o) {
      let l = this.dom.ownerDocument.defaultView || window;
      o = { left: 0, top: 0, right: l.innerWidth, bottom: l.innerHeight };
    }
    return s.top > Math.min(o.bottom, t.bottom) - 10 || s.bottom < Math.max(o.top, t.top) + 10 ? null : this.view.state.facet(g).positionInfo(this.view, t, s, n, o, this.dom);
  }
  placeInfo(e) {
    this.info && (e ? (e.style && (this.info.style.cssText = e.style), this.info.className = "cm-tooltip cm-completionInfo " + (e.class || "")) : this.info.style.cssText = "top: -1e6px");
  }
  createListBox(e, t, n) {
    const s = document.createElement("ul");
    s.id = t, s.setAttribute("role", "listbox"), s.setAttribute("aria-expanded", "true"), s.setAttribute("aria-label", this.view.state.phrase("Completions"));
    let o = null;
    for (let l = n.from; l < n.to; l++) {
      let { completion: r, match: a } = e[l], { section: c } = r;
      if (c) {
        let p = typeof c == "string" ? c : c.name;
        if (p != o && (l > n.from || n.from == 0))
          if (o = p, typeof c != "string" && c.header)
            s.appendChild(c.header(c));
          else {
            let u = s.appendChild(document.createElement("completion-section"));
            u.textContent = p;
          }
      }
      const f = s.appendChild(document.createElement("li"));
      f.id = t + "-" + l, f.setAttribute("role", "option");
      let h = this.optionClass(r);
      h && (f.className = h);
      for (let p of this.optionContent) {
        let u = p(r, this.view.state, this.view, a);
        u && f.appendChild(u);
      }
    }
    return n.from && s.classList.add("cm-completionListIncompleteTop"), n.to < e.length && s.classList.add("cm-completionListIncompleteBottom"), s;
  }
  destroyInfo() {
    this.info && (this.infoDestroy && this.infoDestroy(), this.info.remove(), this.info = null);
  }
  destroy() {
    this.destroyInfo();
  }
}
function Ge(i, e) {
  return (t) => new Ye(t, i, e);
}
function Je(i, e) {
  let t = i.getBoundingClientRect(), n = e.getBoundingClientRect(), s = t.height / i.offsetHeight;
  n.top < t.top ? i.scrollTop -= (t.top - n.top) / s : n.bottom > t.bottom && (i.scrollTop += (n.bottom - t.bottom) / s);
}
function fe(i) {
  return (i.boost || 0) * 100 + (i.apply ? 10 : 0) + (i.info ? 5 : 0) + (i.type ? 1 : 0);
}
function Ze(i, e) {
  let t = [], n = null, s = (c) => {
    t.push(c);
    let { section: f } = c.completion;
    if (f) {
      n || (n = []);
      let h = typeof f == "string" ? f : f.name;
      n.some((p) => p.name == h) || n.push(typeof f == "string" ? { name: h } : f);
    }
  }, o = e.facet(g);
  for (let c of i)
    if (c.hasResult()) {
      let f = c.result.getMatch;
      if (c.result.filter === !1)
        for (let h of c.result.options)
          s(new re(h, c.source, f ? f(h) : [], 1e9 - t.length));
      else {
        let h = e.sliceDoc(c.from, c.to), p, u = o.filterStrict ? new Ke(h) : new ze(h);
        for (let m of c.result.options)
          if (p = u.match(m.label)) {
            let w = m.displayLabel ? f ? f(m, p.matched) : [] : p.matched;
            s(new re(m, c.source, w, p.score + (m.boost || 0)));
          }
      }
    }
  if (n) {
    let c = /* @__PURE__ */ Object.create(null), f = 0, h = (p, u) => {
      var m, w;
      return ((m = p.rank) !== null && m !== void 0 ? m : 1e9) - ((w = u.rank) !== null && w !== void 0 ? w : 1e9) || (p.name < u.name ? -1 : 1);
    };
    for (let p of n.sort(h))
      f -= 1e5, c[p.name] = f;
    for (let p of t) {
      let { section: u } = p.completion;
      u && (p.score += c[typeof u == "string" ? u : u.name]);
    }
  }
  let l = [], r = null, a = o.compareCompletions;
  for (let c of t.sort((f, h) => h.score - f.score || a(f.completion, h.completion))) {
    let f = c.completion;
    !r || r.label != f.label || r.detail != f.detail || r.type != null && f.type != null && r.type != f.type || r.apply != f.apply || r.boost != f.boost ? l.push(c) : fe(c.completion) > fe(r) && (l[l.length - 1] = c), r = c.completion;
  }
  return l;
}
class R {
  constructor(e, t, n, s, o, l) {
    this.options = e, this.attrs = t, this.tooltip = n, this.timestamp = s, this.selected = o, this.disabled = l;
  }
  setSelected(e, t) {
    return e == this.selected || e >= this.options.length ? this : new R(this.options, he(t, e), this.tooltip, this.timestamp, e, this.disabled);
  }
  static build(e, t, n, s, o) {
    let l = Ze(e, t);
    if (!l.length)
      return s && e.some(
        (a) => a.state == 1
        /* State.Pending */
      ) ? new R(s.options, s.attrs, s.tooltip, s.timestamp, s.selected, !0) : null;
    let r = t.facet(g).selectOnOpen ? 0 : -1;
    if (s && s.selected != r && s.selected != -1) {
      let a = s.options[s.selected].completion;
      for (let c = 0; c < l.length; c++)
        if (l[c].completion == a) {
          r = c;
          break;
        }
    }
    return new R(l, he(n, r), {
      pos: e.reduce((a, c) => c.hasResult() ? Math.min(a, c.from) : a, 1e8),
      create: nt,
      above: o.aboveCursor
    }, s ? s.timestamp : Date.now(), r, !1);
  }
  map(e) {
    return new R(this.options, this.attrs, Object.assign(Object.assign({}, this.tooltip), { pos: e.mapPos(this.tooltip.pos) }), this.timestamp, this.selected, this.disabled);
  }
}
class N {
  constructor(e, t, n) {
    this.active = e, this.id = t, this.open = n;
  }
  static start() {
    return new N(tt, "cm-ac-" + Math.floor(Math.random() * 2e6).toString(36), null);
  }
  update(e) {
    let { state: t } = e, n = t.facet(g), o = (n.override || t.languageDataAt("autocomplete", O(t)).map(qe)).map((r) => (this.active.find((c) => c.source == r) || new y(
      r,
      this.active.some(
        (c) => c.state != 0
        /* State.Inactive */
      ) ? 1 : 0
      /* State.Inactive */
    )).update(e, n));
    o.length == this.active.length && o.every((r, a) => r == this.active[a]) && (o = this.active);
    let l = this.open;
    l && e.docChanged && (l = l.map(e.changes)), e.selection || o.some((r) => r.hasResult() && e.changes.touchesRange(r.from, r.to)) || !_e(o, this.active) ? l = R.build(o, t, this.id, l, n) : l && l.disabled && !o.some(
      (r) => r.state == 1
      /* State.Pending */
    ) && (l = null), !l && o.every(
      (r) => r.state != 1
      /* State.Pending */
    ) && o.some((r) => r.hasResult()) && (o = o.map((r) => r.hasResult() ? new y(
      r.source,
      0
      /* State.Inactive */
    ) : r));
    for (let r of e.effects)
      r.is(Se) && (l = l && l.setSelected(r.value, this.id));
    return o == this.active && l == this.open ? this : new N(o, this.id, l);
  }
  get tooltip() {
    return this.open ? this.open.tooltip : null;
  }
  get attrs() {
    return this.open ? this.open.attrs : et;
  }
}
function _e(i, e) {
  if (i == e)
    return !0;
  for (let t = 0, n = 0; ; ) {
    for (; t < i.length && !i[t].hasResult; )
      t++;
    for (; n < e.length && !e[n].hasResult; )
      n++;
    let s = t == i.length, o = n == e.length;
    if (s || o)
      return s == o;
    if (i[t++].result != e[n++].result)
      return !1;
  }
}
const et = {
  "aria-autocomplete": "list"
};
function he(i, e) {
  let t = {
    "aria-autocomplete": "list",
    "aria-haspopup": "listbox",
    "aria-controls": i
  };
  return e > -1 && (t["aria-activedescendant"] = i + "-" + e), t;
}
const tt = [];
function Z(i) {
  return i.isUserEvent("input.type") ? "input" : i.isUserEvent("delete.backward") ? "delete" : null;
}
class y {
  constructor(e, t, n = -1) {
    this.source = e, this.state = t, this.explicitPos = n;
  }
  hasResult() {
    return !1;
  }
  update(e, t) {
    let n = Z(e), s = this;
    n ? s = s.handleUserEvent(e, n, t) : e.docChanged ? s = s.handleChange(e) : e.selection && s.state != 0 && (s = new y(
      s.source,
      0
      /* State.Inactive */
    ));
    for (let o of e.effects)
      if (o.is(W))
        s = new y(s.source, 1, o.value ? O(e.state) : -1);
      else if (o.is(B))
        s = new y(
          s.source,
          0
          /* State.Inactive */
        );
      else if (o.is(ve))
        for (let l of o.value)
          l.source == s.source && (s = l);
    return s;
  }
  handleUserEvent(e, t, n) {
    return t == "delete" || !n.activateOnTyping ? this.map(e.changes) : new y(
      this.source,
      1
      /* State.Pending */
    );
  }
  handleChange(e) {
    return e.changes.touchesRange(O(e.startState)) ? new y(
      this.source,
      0
      /* State.Inactive */
    ) : this.map(e.changes);
  }
  map(e) {
    return e.empty || this.explicitPos < 0 ? this : new y(this.source, this.state, e.mapPos(this.explicitPos));
  }
}
class A extends y {
  constructor(e, t, n, s, o) {
    super(e, 2, t), this.result = n, this.from = s, this.to = o;
  }
  hasResult() {
    return !0;
  }
  handleUserEvent(e, t, n) {
    var s;
    let o = this.result;
    o.map && !e.changes.empty && (o = o.map(o, e.changes));
    let l = e.changes.mapPos(this.from), r = e.changes.mapPos(this.to, 1), a = O(e.state);
    if ((this.explicitPos < 0 ? a <= l : a < this.from) || a > r || !o || t == "delete" && O(e.startState) == this.from)
      return new y(
        this.source,
        t == "input" && n.activateOnTyping ? 1 : 0
        /* State.Inactive */
      );
    let c = this.explicitPos < 0 ? -1 : e.changes.mapPos(this.explicitPos);
    return it(o.validFor, e.state, l, r) ? new A(this.source, c, o, l, r) : o.update && (o = o.update(o, l, r, new xe(e.state, a, c >= 0))) ? new A(this.source, c, o, o.from, (s = o.to) !== null && s !== void 0 ? s : O(e.state)) : new y(this.source, 1, c);
  }
  handleChange(e) {
    return e.changes.touchesRange(this.from, this.to) ? new y(
      this.source,
      0
      /* State.Inactive */
    ) : this.map(e.changes);
  }
  map(e) {
    return e.empty ? this : (this.result.map ? this.result.map(this.result, e) : this.result) ? new A(this.source, this.explicitPos < 0 ? -1 : e.mapPos(this.explicitPos), this.result, e.mapPos(this.from), e.mapPos(this.to, 1)) : new y(
      this.source,
      0
      /* State.Inactive */
    );
  }
}
function it(i, e, t, n) {
  if (!i)
    return !1;
  let s = e.sliceDoc(t, n);
  return typeof i == "function" ? i(s, t, n, e) : we(i, !0).test(s);
}
const ve = /* @__PURE__ */ T.define({
  map(i, e) {
    return i.map((t) => t.map(e));
  }
}), Se = /* @__PURE__ */ T.define(), x = /* @__PURE__ */ ee.define({
  create() {
    return N.start();
  },
  update(i, e) {
    return i.update(e);
  },
  provide: (i) => [
    Fe.from(i, (e) => e.tooltip),
    D.contentAttributes.from(i, (e) => e.attrs)
  ]
});
function te(i, e) {
  const t = e.completion.apply || e.completion.label;
  let n = i.state.field(x).active.find((s) => s.source == e.source);
  return n instanceof A ? (typeof t == "string" ? i.dispatch(Object.assign(Object.assign({}, He(i.state, t, n.from, n.to)), { annotations: Ce.of(e.completion) })) : t(i, e.completion, n.from, n.to), !0) : !1;
}
const nt = /* @__PURE__ */ Ge(x, te);
function U(i, e = "option") {
  return (t) => {
    let n = t.state.field(x, !1);
    if (!n || !n.open || n.open.disabled || Date.now() - n.open.timestamp < t.state.facet(g).interactionDelay)
      return !1;
    let s = 1, o;
    e == "page" && (o = be(t, n.open.tooltip)) && (s = Math.max(2, Math.floor(o.dom.offsetHeight / o.dom.querySelector("li").offsetHeight) - 1));
    let { length: l } = n.open.options, r = n.open.selected > -1 ? n.open.selected + s * (i ? 1 : -1) : i ? 0 : l - 1;
    return r < 0 ? r = e == "page" ? 0 : l - 1 : r >= l && (r = e == "page" ? l - 1 : 0), t.dispatch({ effects: Se.of(r) }), !0;
  };
}
const st = (i) => {
  let e = i.state.field(x, !1);
  return i.state.readOnly || !e || !e.open || e.open.selected < 0 || e.open.disabled || Date.now() - e.open.timestamp < i.state.facet(g).interactionDelay ? !1 : te(i, e.open.options[e.open.selected]);
}, ot = (i) => i.state.field(x, !1) ? (i.dispatch({ effects: W.of(!0) }), !0) : !1, lt = (i) => {
  let e = i.state.field(x, !1);
  return !e || !e.active.some(
    (t) => t.state != 0
    /* State.Inactive */
  ) ? !1 : (i.dispatch({ effects: B.of(null) }), !0);
};
class rt {
  constructor(e, t) {
    this.active = e, this.context = t, this.time = Date.now(), this.updates = [], this.done = void 0;
  }
}
const at = 50, ct = 1e3, ft = /* @__PURE__ */ je.fromClass(class {
  constructor(i) {
    this.view = i, this.debounceUpdate = -1, this.running = [], this.debounceAccept = -1, this.pendingStart = !1, this.composing = 0;
    for (let e of i.state.field(x).active)
      e.state == 1 && this.startQuery(e);
  }
  update(i) {
    let e = i.state.field(x);
    if (!i.selectionSet && !i.docChanged && i.startState.field(x) == e)
      return;
    let t = i.transactions.some((s) => (s.selection || s.docChanged) && !Z(s));
    for (let s = 0; s < this.running.length; s++) {
      let o = this.running[s];
      if (t || o.updates.length + i.transactions.length > at && Date.now() - o.time > ct) {
        for (let l of o.context.abortListeners)
          try {
            l();
          } catch (r) {
            J(this.view.state, r);
          }
        o.context.abortListeners = null, this.running.splice(s--, 1);
      } else
        o.updates.push(...i.transactions);
    }
    this.debounceUpdate > -1 && clearTimeout(this.debounceUpdate), i.transactions.some((s) => s.effects.some((o) => o.is(W))) && (this.pendingStart = !0);
    let n = this.pendingStart ? 50 : i.state.facet(g).activateOnTypingDelay;
    if (this.debounceUpdate = e.active.some((s) => s.state == 1 && !this.running.some((o) => o.active.source == s.source)) ? setTimeout(() => this.startUpdate(), n) : -1, this.composing != 0)
      for (let s of i.transactions)
        Z(s) == "input" ? this.composing = 2 : this.composing == 2 && s.selection && (this.composing = 3);
  }
  startUpdate() {
    this.debounceUpdate = -1, this.pendingStart = !1;
    let { state: i } = this.view, e = i.field(x);
    for (let t of e.active)
      t.state == 1 && !this.running.some((n) => n.active.source == t.source) && this.startQuery(t);
  }
  startQuery(i) {
    let { state: e } = this.view, t = O(e), n = new xe(e, t, i.explicitPos == t), s = new rt(i, n);
    this.running.push(s), Promise.resolve(i.source(n)).then((o) => {
      s.context.aborted || (s.done = o || null, this.scheduleAccept());
    }, (o) => {
      this.view.dispatch({ effects: B.of(null) }), J(this.view.state, o);
    });
  }
  scheduleAccept() {
    this.running.every((i) => i.done !== void 0) ? this.accept() : this.debounceAccept < 0 && (this.debounceAccept = setTimeout(() => this.accept(), this.view.state.facet(g).updateSyncTime));
  }
  // For each finished query in this.running, try to create a result
  // or, if appropriate, restart the query.
  accept() {
    var i;
    this.debounceAccept > -1 && clearTimeout(this.debounceAccept), this.debounceAccept = -1;
    let e = [], t = this.view.state.facet(g);
    for (let n = 0; n < this.running.length; n++) {
      let s = this.running[n];
      if (s.done === void 0)
        continue;
      if (this.running.splice(n--, 1), s.done) {
        let l = new A(s.active.source, s.active.explicitPos, s.done, s.done.from, (i = s.done.to) !== null && i !== void 0 ? i : O(s.updates.length ? s.updates[0].startState : this.view.state));
        for (let r of s.updates)
          l = l.update(r, t);
        if (l.hasResult()) {
          e.push(l);
          continue;
        }
      }
      let o = this.view.state.field(x).active.find((l) => l.source == s.active.source);
      if (o && o.state == 1)
        if (s.done == null) {
          let l = new y(
            s.active.source,
            0
            /* State.Inactive */
          );
          for (let r of s.updates)
            l = l.update(r, t);
          l.state != 1 && e.push(l);
        } else
          this.startQuery(o);
    }
    e.length && this.view.dispatch({ effects: ve.of(e) });
  }
}, {
  eventHandlers: {
    blur(i) {
      let e = this.view.state.field(x, !1);
      if (e && e.tooltip && this.view.state.facet(g).closeOnBlur) {
        let t = e.open && be(this.view, e.open.tooltip);
        (!t || !t.dom.contains(i.relatedTarget)) && setTimeout(() => this.view.dispatch({ effects: B.of(null) }), 10);
      }
    },
    compositionstart() {
      this.composing = 1;
    },
    compositionend() {
      this.composing == 3 && setTimeout(() => this.view.dispatch({ effects: W.of(!1) }), 20), this.composing = 0;
    }
  }
}), ht = typeof navigator == "object" && /* @__PURE__ */ /Win/.test(navigator.platform), pt = /* @__PURE__ */ _.highest(/* @__PURE__ */ D.domEventHandlers({
  keydown(i, e) {
    let t = e.state.field(x, !1);
    if (!t || !t.open || t.open.disabled || t.open.selected < 0 || i.key.length > 1 || i.ctrlKey && !(ht && i.altKey) || i.metaKey)
      return !1;
    let n = t.open.options[t.open.selected], s = t.active.find((l) => l.source == n.source), o = n.completion.commitCharacters || s.result.commitCharacters;
    return o && o.indexOf(i.key) > -1 && te(e, n), !1;
  }
})), Ie = /* @__PURE__ */ D.baseTheme({
  ".cm-tooltip.cm-tooltip-autocomplete": {
    "& > ul": {
      fontFamily: "monospace",
      whiteSpace: "nowrap",
      overflow: "hidden auto",
      maxWidth_fallback: "700px",
      maxWidth: "min(700px, 95vw)",
      minWidth: "250px",
      maxHeight: "10em",
      height: "100%",
      listStyle: "none",
      margin: 0,
      padding: 0,
      "& > li, & > completion-section": {
        padding: "1px 3px",
        lineHeight: 1.2
      },
      "& > li": {
        overflowX: "hidden",
        textOverflow: "ellipsis",
        cursor: "pointer"
      },
      "& > completion-section": {
        display: "list-item",
        borderBottom: "1px solid silver",
        paddingLeft: "0.5em",
        opacity: 0.7
      }
    }
  },
  "&light .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#17c",
    color: "white"
  },
  "&light .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#777"
  },
  "&dark .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#347",
    color: "white"
  },
  "&dark .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#444"
  },
  ".cm-completionListIncompleteTop:before, .cm-completionListIncompleteBottom:after": {
    content: '"···"',
    opacity: 0.5,
    display: "block",
    textAlign: "center"
  },
  ".cm-tooltip.cm-completionInfo": {
    position: "absolute",
    padding: "3px 9px",
    width: "max-content",
    maxWidth: "400px",
    boxSizing: "border-box"
  },
  ".cm-completionInfo.cm-completionInfo-left": { right: "100%" },
  ".cm-completionInfo.cm-completionInfo-right": { left: "100%" },
  ".cm-completionInfo.cm-completionInfo-left-narrow": { right: "30px" },
  ".cm-completionInfo.cm-completionInfo-right-narrow": { left: "30px" },
  "&light .cm-snippetField": { backgroundColor: "#00000022" },
  "&dark .cm-snippetField": { backgroundColor: "#ffffff22" },
  ".cm-snippetFieldPosition": {
    verticalAlign: "text-top",
    width: 0,
    height: "1.15em",
    display: "inline-block",
    margin: "0 -0.7px -.7em",
    borderLeft: "1.4px dotted #888"
  },
  ".cm-completionMatchedText": {
    textDecoration: "underline"
  },
  ".cm-completionDetail": {
    marginLeft: "0.5em",
    fontStyle: "italic"
  },
  ".cm-completionIcon": {
    fontSize: "90%",
    width: ".8em",
    display: "inline-block",
    textAlign: "center",
    paddingRight: ".6em",
    opacity: "0.6",
    boxSizing: "content-box"
  },
  ".cm-completionIcon-function, .cm-completionIcon-method": {
    "&:after": { content: "'ƒ'" }
  },
  ".cm-completionIcon-class": {
    "&:after": { content: "'○'" }
  },
  ".cm-completionIcon-interface": {
    "&:after": { content: "'◌'" }
  },
  ".cm-completionIcon-variable": {
    "&:after": { content: "'𝑥'" }
  },
  ".cm-completionIcon-constant": {
    "&:after": { content: "'𝐶'" }
  },
  ".cm-completionIcon-type": {
    "&:after": { content: "'𝑡'" }
  },
  ".cm-completionIcon-enum": {
    "&:after": { content: "'∪'" }
  },
  ".cm-completionIcon-property": {
    "&:after": { content: "'□'" }
  },
  ".cm-completionIcon-keyword": {
    "&:after": { content: "'🔑︎'" }
    // Disable emoji rendering
  },
  ".cm-completionIcon-namespace": {
    "&:after": { content: "'▢'" }
  },
  ".cm-completionIcon-text": {
    "&:after": { content: "'abc'", fontSize: "50%", verticalAlign: "middle" }
  }
});
class ut {
  constructor(e, t, n, s) {
    this.field = e, this.line = t, this.from = n, this.to = s;
  }
}
class ie {
  constructor(e, t, n) {
    this.field = e, this.from = t, this.to = n;
  }
  map(e) {
    let t = e.mapPos(this.from, -1, G.TrackDel), n = e.mapPos(this.to, 1, G.TrackDel);
    return t == null || n == null ? null : new ie(this.field, t, n);
  }
}
class ne {
  constructor(e, t) {
    this.lines = e, this.fieldPositions = t;
  }
  instantiate(e, t) {
    let n = [], s = [t], o = e.doc.lineAt(t), l = /^\s*/.exec(o.text)[0];
    for (let a of this.lines) {
      if (n.length) {
        let c = l, f = /^\t*/.exec(a)[0].length;
        for (let h = 0; h < f; h++)
          c += e.facet(We);
        s.push(t + c.length - f), a = c + a.slice(f);
      }
      n.push(a), t += a.length + 1;
    }
    let r = this.fieldPositions.map((a) => new ie(a.field, s[a.line] + a.from, s[a.line] + a.to));
    return { text: n, ranges: r };
  }
  static parse(e) {
    let t = [], n = [], s = [], o;
    for (let l of e.split(/\r\n?|\n/)) {
      for (; o = /[#$]\{(?:(\d+)(?::([^}]*))?|([^}]*))\}/.exec(l); ) {
        let r = o[1] ? +o[1] : null, a = o[2] || o[3] || "", c = -1;
        for (let f = 0; f < t.length; f++)
          (r != null ? t[f].seq == r : a && t[f].name == a) && (c = f);
        if (c < 0) {
          let f = 0;
          for (; f < t.length && (r == null || t[f].seq != null && t[f].seq < r); )
            f++;
          t.splice(f, 0, { seq: r, name: a }), c = f;
          for (let h of s)
            h.field >= c && h.field++;
        }
        s.push(new ut(c, n.length, o.index, o.index + a.length)), l = l.slice(0, o.index) + a + l.slice(o.index + o[0].length);
      }
      for (let r; r = /\\([{}])/.exec(l); ) {
        l = l.slice(0, r.index) + r[1] + l.slice(r.index + r[0].length);
        for (let a of s)
          a.line == n.length && a.from > r.index && (a.from--, a.to--);
      }
      n.push(l);
    }
    return new ne(n, s);
  }
}
let dt = /* @__PURE__ */ V.widget({ widget: /* @__PURE__ */ new class extends $e {
  toDOM() {
    let i = document.createElement("span");
    return i.className = "cm-snippetFieldPosition", i;
  }
  ignoreEvent() {
    return !1;
  }
}() }), mt = /* @__PURE__ */ V.mark({ class: "cm-snippetField" });
class L {
  constructor(e, t) {
    this.ranges = e, this.active = t, this.deco = V.set(e.map((n) => (n.from == n.to ? dt : mt).range(n.from, n.to)));
  }
  map(e) {
    let t = [];
    for (let n of this.ranges) {
      let s = n.map(e);
      if (!s)
        return null;
      t.push(s);
    }
    return new L(t, this.active);
  }
  selectionInsideField(e) {
    return e.ranges.every((t) => this.ranges.some((n) => n.field == this.active && n.from <= t.from && n.to >= t.to));
  }
}
const j = /* @__PURE__ */ T.define({
  map(i, e) {
    return i && i.map(e);
  }
}), gt = /* @__PURE__ */ T.define(), k = /* @__PURE__ */ ee.define({
  create() {
    return null;
  },
  update(i, e) {
    for (let t of e.effects) {
      if (t.is(j))
        return t.value;
      if (t.is(gt) && i)
        return new L(i.ranges, t.value);
    }
    return i && e.docChanged && (i = i.map(e.changes)), i && e.selection && !i.selectionInsideField(e.selection) && (i = null), i;
  },
  provide: (i) => D.decorations.from(i, (e) => e ? e.deco : V.none)
});
function se(i, e) {
  return C.create(i.filter((t) => t.field == e).map((t) => C.range(t.from, t.to)));
}
function yt(i) {
  let e = ne.parse(i);
  return (t, n, s, o) => {
    let { text: l, ranges: r } = e.instantiate(t.state, s), a = {
      changes: { from: s, to: o, insert: Ae.of(l) },
      scrollIntoView: !0,
      annotations: n ? [Ce.of(n), De.userEvent.of("input.complete")] : void 0
    };
    if (r.length && (a.selection = se(r, 0)), r.some((c) => c.field > 0)) {
      let c = new L(r, 0), f = a.effects = [j.of(c)];
      t.state.field(k, !1) === void 0 && f.push(T.appendConfig.of([k, vt, St, Ie]));
    }
    t.dispatch(t.state.update(a));
  };
}
function Oe(i) {
  return ({ state: e, dispatch: t }) => {
    let n = e.field(k, !1);
    if (!n || i < 0 && n.active == 0)
      return !1;
    let s = n.active + i, o = i > 0 && !n.ranges.some((l) => l.field == s + i);
    return t(e.update({
      selection: se(n.ranges, s),
      effects: j.of(o ? null : new L(n.ranges, s)),
      scrollIntoView: !0
    })), !0;
  };
}
const bt = ({ state: i, dispatch: e }) => i.field(k, !1) ? (e(i.update({ effects: j.of(null) })), !0) : !1, xt = /* @__PURE__ */ Oe(1), wt = /* @__PURE__ */ Oe(-1), Ct = [
  { key: "Tab", run: xt, shift: wt },
  { key: "Escape", run: bt }
], pe = /* @__PURE__ */ me.define({
  combine(i) {
    return i.length ? i[0] : Ct;
  }
}), vt = /* @__PURE__ */ _.highest(/* @__PURE__ */ ye.compute([pe], (i) => i.facet(pe)));
function Ut(i, e) {
  return Object.assign(Object.assign({}, e), { apply: yt(i) });
}
const St = /* @__PURE__ */ D.domEventHandlers({
  mousedown(i, e) {
    let t = e.state.field(k, !1), n;
    if (!t || (n = e.posAtCoords({ x: i.clientX, y: i.clientY })) == null)
      return !1;
    let s = t.ranges.find((o) => o.from <= n && o.to >= n);
    return !s || s.field == t.active ? !1 : (e.dispatch({
      selection: se(t.ranges, s.field),
      effects: j.of(t.ranges.some((o) => o.field > s.field) ? new L(t.ranges, s.field) : null),
      scrollIntoView: !0
    }), !0);
  }
}), F = {
  brackets: ["(", "[", "{", "'", '"'],
  before: ")]}:;>",
  stringPrefixes: []
}, E = /* @__PURE__ */ T.define({
  map(i, e) {
    let t = e.mapPos(i, -1, G.TrackAfter);
    return t ?? void 0;
  }
}), oe = /* @__PURE__ */ new class extends Le {
}();
oe.startSide = 1;
oe.endSide = -1;
const Te = /* @__PURE__ */ ee.define({
  create() {
    return ke.empty;
  },
  update(i, e) {
    if (i = i.map(e.changes), e.selection) {
      let t = e.state.doc.lineAt(e.selection.main.head);
      i = i.update({ filter: (n) => n >= t.from && n <= t.to });
    }
    for (let t of e.effects)
      t.is(E) && (i = i.update({ add: [oe.range(t.value, t.value + 1)] }));
    return i;
  }
});
function Wt() {
  return [Ot, Te];
}
const X = "()[]{}<>";
function Ee(i) {
  for (let e = 0; e < X.length; e += 2)
    if (X.charCodeAt(e) == i)
      return X.charAt(e + 1);
  return ge(i < 128 ? i : i + 1);
}
function Pe(i, e) {
  return i.languageDataAt("closeBrackets", e)[0] || F;
}
const It = typeof navigator == "object" && /* @__PURE__ */ /Android\b/.test(navigator.userAgent), Ot = /* @__PURE__ */ D.inputHandler.of((i, e, t, n) => {
  if ((It ? i.composing : i.compositionStarted) || i.state.readOnly)
    return !1;
  let s = i.state.selection.main;
  if (n.length > 2 || n.length == 2 && I(v(n, 0)) == 1 || e != s.from || t != s.to)
    return !1;
  let o = Et(i.state, n);
  return o ? (i.dispatch(o), !0) : !1;
}), Tt = ({ state: i, dispatch: e }) => {
  if (i.readOnly)
    return !1;
  let n = Pe(i, i.selection.main.head).brackets || F.brackets, s = null, o = i.changeByRange((l) => {
    if (l.empty) {
      let r = Pt(i.doc, l.head);
      for (let a of n)
        if (a == r && q(i.doc, l.head) == Ee(v(a, 0)))
          return {
            changes: { from: l.head - a.length, to: l.head + a.length },
            range: C.cursor(l.head - a.length)
          };
    }
    return { range: s = l };
  });
  return s || e(i.update(o, { scrollIntoView: !0, userEvent: "delete.backward" })), !s;
}, Nt = [
  { key: "Backspace", run: Tt }
];
function Et(i, e) {
  let t = Pe(i, i.selection.main.head), n = t.brackets || F.brackets;
  for (let s of n) {
    let o = Ee(v(s, 0));
    if (e == s)
      return o == s ? Dt(i, s, n.indexOf(s + s + s) > -1, t) : Rt(i, s, o, t.before || F.before);
    if (e == o && Re(i, i.selection.main.from))
      return At(i, s, o);
  }
  return null;
}
function Re(i, e) {
  let t = !1;
  return i.field(Te).between(0, i.doc.length, (n) => {
    n == e && (t = !0);
  }), t;
}
function q(i, e) {
  let t = i.sliceString(e, e + 2);
  return t.slice(0, I(v(t, 0)));
}
function Pt(i, e) {
  let t = i.sliceString(e - 2, e);
  return I(v(t, 0)) == t.length ? t : t.slice(1);
}
function Rt(i, e, t, n) {
  let s = null, o = i.changeByRange((l) => {
    if (!l.empty)
      return {
        changes: [{ insert: e, from: l.from }, { insert: t, from: l.to }],
        effects: E.of(l.to + e.length),
        range: C.range(l.anchor + e.length, l.head + e.length)
      };
    let r = q(i.doc, l.head);
    return !r || /\s/.test(r) || n.indexOf(r) > -1 ? {
      changes: { insert: e + t, from: l.head },
      effects: E.of(l.head + e.length),
      range: C.cursor(l.head + e.length)
    } : { range: s = l };
  });
  return s ? null : i.update(o, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function At(i, e, t) {
  let n = null, s = i.changeByRange((o) => o.empty && q(i.doc, o.head) == t ? {
    changes: { from: o.head, to: o.head + t.length, insert: t },
    range: C.cursor(o.head + t.length)
  } : n = { range: o });
  return n ? null : i.update(s, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function Dt(i, e, t, n) {
  let s = n.stringPrefixes || F.stringPrefixes, o = null, l = i.changeByRange((r) => {
    if (!r.empty)
      return {
        changes: [{ insert: e, from: r.from }, { insert: e, from: r.to }],
        effects: E.of(r.to + e.length),
        range: C.range(r.anchor + e.length, r.head + e.length)
      };
    let a = r.head, c = q(i.doc, a), f;
    if (c == e) {
      if (ue(i, a))
        return {
          changes: { insert: e + e, from: a },
          effects: E.of(a + e.length),
          range: C.cursor(a + e.length)
        };
      if (Re(i, a)) {
        let p = t && i.sliceDoc(a, a + e.length * 3) == e + e + e ? e + e + e : e;
        return {
          changes: { from: a, to: a + p.length, insert: p },
          range: C.cursor(a + p.length)
        };
      }
    } else {
      if (t && i.sliceDoc(a - 2 * e.length, a) == e + e && (f = de(i, a - 2 * e.length, s)) > -1 && ue(i, f))
        return {
          changes: { insert: e + e + e + e, from: a },
          effects: E.of(a + e.length),
          range: C.cursor(a + e.length)
        };
      if (i.charCategorizer(a)(c) != Y.Word && de(i, a, s) > -1 && !Lt(i, a, e, s))
        return {
          changes: { insert: e + e, from: a },
          effects: E.of(a + e.length),
          range: C.cursor(a + e.length)
        };
    }
    return { range: o = r };
  });
  return o ? null : i.update(l, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function ue(i, e) {
  let t = H(i).resolveInner(e + 1);
  return t.parent && t.from == e;
}
function Lt(i, e, t, n) {
  let s = H(i).resolveInner(e, -1), o = n.reduce((l, r) => Math.max(l, r.length), 0);
  for (let l = 0; l < 5; l++) {
    let r = i.sliceDoc(s.from, Math.min(s.to, s.from + t.length + o)), a = r.indexOf(t);
    if (!a || a > -1 && n.indexOf(r.slice(0, a)) > -1) {
      let f = s.firstChild;
      for (; f && f.from == s.from && f.to - f.from > t.length + a; ) {
        if (i.sliceDoc(f.to - t.length, f.to) == t)
          return !1;
        f = f.firstChild;
      }
      return !0;
    }
    let c = s.to == e && s.parent;
    if (!c)
      break;
    s = c;
  }
  return !1;
}
function de(i, e, t) {
  let n = i.charCategorizer(e);
  if (n(i.sliceDoc(e - 1, e)) != Y.Word)
    return e;
  for (let s of t) {
    let o = e - s.length;
    if (i.sliceDoc(o, e) == s && n(i.sliceDoc(o - 1, o)) != Y.Word)
      return o;
  }
  return -1;
}
function Vt(i = {}) {
  return [
    pt,
    x,
    g.of(i),
    ft,
    Bt,
    Ie
  ];
}
const Mt = [
  { key: "Ctrl-Space", run: ot },
  { key: "Escape", run: lt },
  { key: "ArrowDown", run: /* @__PURE__ */ U(!0) },
  { key: "ArrowUp", run: /* @__PURE__ */ U(!1) },
  { key: "PageDown", run: /* @__PURE__ */ U(!0, "page") },
  { key: "PageUp", run: /* @__PURE__ */ U(!1, "page") },
  { key: "Enter", run: st }
], Bt = /* @__PURE__ */ _.highest(/* @__PURE__ */ ye.computeN([g], (i) => i.facet(g).defaultKeymap ? [Mt] : []));
export {
  xe as CompletionContext,
  st as acceptCompletion,
  Vt as autocompletion,
  bt as clearSnippet,
  Wt as closeBrackets,
  Nt as closeBracketsKeymap,
  lt as closeCompletion,
  Ve as completeFromList,
  Mt as completionKeymap,
  Tt as deleteBracketPair,
  $t as ifNotIn,
  Et as insertBracket,
  He as insertCompletionText,
  U as moveCompletionSelection,
  xt as nextSnippetField,
  Ce as pickedCompletion,
  wt as prevSnippetField,
  yt as snippet,
  Ut as snippetCompletion,
  pe as snippetKeymap,
  ot as startCompletion
};
